src/Entity/User.php
<?php

namespace App\Entity;

use App\Repository\UserRepository;
use DateTime;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use phpDocumentor\Reflection\Types\Boolean;
use Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface;
use Symfony\Component\Security\Core\User\UserInterface;

#[ORM\Entity(repositoryClass: UserRepository::class)]
class User implements UserInterface, PasswordAuthenticatedUserInterface
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: 'integer')]
    private $id;

    #[ORM\Column(type: 'string', length: 180, unique: true)]
    private $email;

    #[ORM\Column(type: 'json')]
    private $roles = [];

    #[ORM\Column(type: 'string')]
    private $password;

    #[ORM\Column(type: 'string', length: 255)]
    private $firstname;

    #[ORM\Column(type: 'string', length: 255)]
    private $lastname;

    #[ORM\OneToMany(mappedBy: 'user', targetEntity: Order::class, orphanRemoval: true)]
    private $orders;

    public function __construct()
    {
        $this->orders = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getEmail(): ?string
    {
        return $this->email;
    }

    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

    /**
     * A visual identifier that represents this user.
     *
     * @see UserInterface
     */
    public function getUserIdentifier(): string
    {
        return (string) $this->email;
    }

    /**
     * @see UserInterface
     */
    public function getRoles(): array
    {
        $roles = $this->roles;
        // guarantee every user at least has ROLE_USER
        $roles[] = 'ROLE_USER';

        return array_unique($roles);
    }

    public function setRoles(array $roles): self
    {
        $this->roles = $roles;

        return $this;
    }

    public function isAdmin()
    {
        return in_array('ROLE_ADMIN', $this->roles);
    }

    /**
     * @see PasswordAuthenticatedUserInterface
     */
    public function getPassword(): string
    {
        return $this->password;
    }

    public function setPassword(string $password): self
    {
        $this->password = $password;

        return $this;
    }

    /**
     * @see UserInterface
     */
    public function eraseCredentials()
    {
        // If you store any temporary, sensitive data on the user, clear it here
        // $this->plainPassword = null;
    }

    public function getFirstname(): ?string
    {
        return $this->firstname;
    }

    public function setFirstname(string $firstname): self
    {
        $this->firstname = $firstname;

        return $this;
    }

    public function getLastname(): ?string
    {
        return $this->lastname;
    }

    public function setLastname(string $lastname): self
    {
        $this->lastname = $lastname;

        return $this;
    }

    public function getCurrentOrder()
    {
        $currentDate = (new \DateTime('now'))->format('m-Y');

        foreach ($this->getOrders() as $order) {

            if ( $order->getDate()->format('m-Y') == $currentDate ) {
                return $order;
            }
        }

        return null;
    }

    public function getPreviousOrders()
    {
        $currentDate = new DateTime('now');
        $orders = [];

        foreach ($this->orders as $order) {
            
            if ($order->getDate()->format('m-Y') !== $currentDate->format('m-Y')) {
                $orders[] = $order;
            }
        }

        return $orders;
    }

    /**
     * @return Collection<int, Order>
     */
    public function getOrders(): Collection
    {
        return $this->orders;
    }

    public function addOrder(Order $order): self
    {
        if (!$this->orders->contains($order)) {
            $this->orders[] = $order;
            $order->setUser($this);
        }

        return $this;
    }

    public function removeOrder(Order $order): self
    {
        if ($this->orders->removeElement($order)) {
            // set the owning side to null (unless already changed)
            if ($order->getUser() === $this) {
                $order->setUser(null);
            }
        }

        return $this;
    }
}

src/Form/UserType.php
<?php

namespace App\Form;

use App\Entity\User;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class UserType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('firstname', TextType::class, [
                'label' => 'Prénom'
            ])
            ->add('lastname', TextType::class, [
                'label' => 'Nom'
            ])
            ->add('email', TextType::class, [
                'label' => 'Adresse mail'
            ])
            ->add('password', TextType::class, [
                'label' => 'Mot de passe'
            ])
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => User::class,
        ]);
    }
}

src/Controller/UserController.php
<?php

namespace App\Controller;

use App\Entity\User;
use App\Form\UserType;
use App\Repository\UserRepository;
use DateTime;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\PasswordHasher\Hasher\UserPasswordHasherInterface;

#[Route('/user')]
class UserController extends AbstractController
{
    #[Route('/new', name: 'app_user_new', methods: ['GET', 'POST'])]
    public function new(Request $request, UserRepository $userRepository, UserPasswordHasherInterface $userPasswordHasher): Response
    {
        $user = new User();
        $form = $this->createForm(UserType::class, $user);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $user->setRoles(["ROLE_USER"]);
            $user->setPassword(
            $userPasswordHasher->hashPassword(
                    $user,
                    $form->get('password')->getData()
                )
            );

            $userRepository->add($user);
            return $this->redirectToRoute('app_home', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('user/new.html.twig', [
            'user' => $user,
            'form' => $form,
            'currentDate' => new DateTime('now')
        ]);
    }

    #[Route('/informations', name: 'app_informations', methods: ['GET'])]
    public function show(): Response
    {
        return $this->getUser() ? $this->render('user/informations.html.twig') : $this->redirectToRoute('app_home');
    }

    // #[Route('/{id}', name: 'app_user_show', methods: ['GET'])]
    // public function show(User $user): Response
    // {
    //     return $this->render('user/show.html.twig', [
    //         'user' => $user,
    //     ]);
    // }

    // #[Route('/{id}/edit', name: 'app_user_edit', methods: ['GET', 'POST'])]
    // public function edit(Request $request, User $user, UserRepository $userRepository): Response
    // {
    //     $form = $this->createForm(UserType::class, $user);
    //     $form->handleRequest($request);

    //     if ($form->isSubmitted() && $form->isValid()) {
    //         $userRepository->add($user);
    //         return $this->redirectToRoute('app_user_index', [], Response::HTTP_SEE_OTHER);
    //     }

    //     return $this->renderForm('user/edit.html.twig', [
    //         'user' => $user,
    //         'form' => $form,
    //     ]);
    // }

    // #[Route('/{id}', name: 'app_user_delete', methods: ['POST'])]
    // public function delete(Request $request, User $user, UserRepository $userRepository): Response
    // {
    //     if ($this->isCsrfTokenValid('delete'.$user->getId(), $request->request->get('_token'))) {
    //         $userRepository->remove($user);
    //     }

    //     return $this->redirectToRoute('app_user_index', [], Response::HTTP_SEE_OTHER);
    // }
}

templates/user/_delete_form.html.twig
<form method="post" action="{{ path('app_user_delete', {'id': user.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ user.id) }}">
    <button class="btn">Delete</button>
</form>

templates/user/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn btn-success">{{ button_label|default('S\'inscrire') }}</button>
{{ form_end(form) }}

templates/user/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit User{% endblock %}

{% block body %}
    <h1>Edit User</h1>

    {{ include('user/_form.html.twig', {'button_label': 'Update'}) }}

    <a href="{{ path('app_user_index') }}">back to list</a>

    {{ include('user/_delete_form.html.twig') }}
{% endblock %}

templates/user/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}User index{% endblock %}

{% block body %}
    <h1>User index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Email</th>
                <th>Roles</th>
                <th>Password</th>
                <th>Firstname</th>
                <th>Lastname</th>
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for user in users %}
            <tr>
                <td>{{ user.id }}</td>
                <td>{{ user.email }}</td>
                <td>{{ user.roles ? user.roles|json_encode : '' }}</td>
                <td>{{ user.password }}</td>
                <td>{{ user.firstname }}</td>
                <td>{{ user.lastname }}</td>
                <td>
                    <a href="{{ path('app_user_show', {'id': user.id}) }}">show</a>
                    <a href="{{ path('app_user_edit', {'id': user.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="7">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a href="{{ path('app_user_new') }}">Create new</a>
{% endblock %}

templates/user/informations.html.twig
{% extends 'base.html.twig' %}

{% block title %}Hello HomeController!{% endblock %}

{% block body %}
    {% if app.user and app.user.currentOrder %}
        {% if app.user.currentOrder.orderItems | length > 0 %}
            <h2>Ma prochaine commande</h2>
            <ul class="OrderList">
                {% for orderItem in app.user.currentOrder.orderItems %}
                    <li class="OrderList__product">
                        <div>
                            <img class="OrderList__product__picture" src="/uploads/{{ orderItem.product.picture }}" alt="">
                            <div class="OrderList__product__informations">
                                <p class="OrderList__product__name">{{ orderItem.product.name }}</p>
                                <p class="OrderList__product__quantity">Quantité : {{ orderItem.quantity }}</p>
                                <p class="OrderList__product__price">Prix : {{ orderItem.product.price * orderItem.quantity }}€ <span>({{ orderItem.quantity }} x {{ orderItem.product.price }}€)</span></p>
                            </div>
                        </div>
                        <a href="{{ path('app_order_remove_product', {'id': orderItem.id}) }}" onclick="return confirm('Êtes-vous sûr de vouloir supprimer la commande ?')">Supprimer de la commande</a>
                    </li>
                {% endfor %}
                <li>
                    {% if app.user.currentOrder.invoices %}
                        {% for invoice in app.user.currentOrder.invoices %}
                            <p>Facture : <a href="/uploads/{{ invoice.filename }}" target="_blank">{{ invoice.filename }}</a></p>
                        {% endfor %}
                    {% endif %}
                </li>
            </ul>
        {% endif %}
    {% endif %}

    
    {% if app.user and app.user.previousOrders %}
        {% if app.user.previousOrders | length > 0 %}
            <h2>Mes dernières commandes</h2>
            {% for order in app.user.previousOrders %}
                <ul class="OrderList">
                    {% for orderItem in order.orderItems %}
                        <li class="OrderList__product">
                            <div>
                                <img class="OrderList__product__picture" src="/uploads/{{ orderItem.product.picture }}" alt="">
                                <div class="OrderList__product__informations">
                                    <p class="OrderList__product__name">{{ orderItem.product.name }}</p>
                                    <p class="OrderList__product__quantity">Quantité : {{ orderItem.quantity }}</p>
                                    <p class="OrderList__product__price">Prix : {{ orderItem.product.price * orderItem.quantity }}€ <span>({{ orderItem.quantity }} x {{ orderItem.product.price }}€)</span></p>
                                </div>
                            </div>
                            <a href="{{ path('app_order_remove_product', {'id': orderItem.id}) }}" onclick="return confirm('Êtes-vous sûr de vouloir supprimer la commande ?')">Supprimer de la commande</a>
                        </li>
                    {% endfor %}
                    <li>
                        {% if order.invoices %}
                            {% for invoice in order.invoices %}
                                <p>Facture : <a href="/uploads/{{ invoice.filename }}" target="_blank">{{ invoice.filename }}</a></p>
                            {% endfor %}
                        {% endif %}
                    </li>
                </ul>
            {% endfor %}
        {% endif %}
    {% endif %}
{% endblock %}

templates/user/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New User{% endblock %}

{% block body %}
    <h1>Inscription</h1>

    {{ include('user/_form.html.twig') }}

    {# <a href="{{ path('app_user_index') }}">back to list</a> #}
{% endblock %}

templates/user/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}User{% endblock %}

{% block body %}
    <h1>User</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ user.id }}</td>
            </tr>
            <tr>
                <th>Email</th>
                <td>{{ user.email }}</td>
            </tr>
            <tr>
                <th>Roles</th>
                <td>{{ user.roles ? user.roles|json_encode : '' }}</td>
            </tr>
            <tr>
                <th>Password</th>
                <td>{{ user.password }}</td>
            </tr>
            <tr>
                <th>Firstname</th>
                <td>{{ user.firstname }}</td>
            </tr>
            <tr>
                <th>Lastname</th>
                <td>{{ user.lastname }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('app_user_index') }}">back to list</a>

    <a href="{{ path('app_user_edit', {'id': user.id}) }}">edit</a>

    {{ include('user/_delete_form.html.twig') }}
{% endblock %}